

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>

#include "MFBO.H"


void err( void )
{ char groupMsg[40];
  char detailMsg[40];

  if ( mfError() != mfeOk )
    {
      mfParMessage( mfError(), groupMsg, detailMsg );
      printf( "%s, %s\n", groupMsg, detailMsg );
      getch();
    }
}

void resErr( int res )
{
  switch (res)
  {
    case mfeOk             : break;
    case mfeImplementation : {
                               printf( "FUNKCJA NIE JEST  ZAIMPLEMENTOWANA DLA TEJ DRUKARKI FISKALNEJ\n" );
                               getch();
                               break;
                             };

    case mfeApplication    : {
                               printf( "BLAD APLIKACJI\n" );
                               exit(0);
                             }

    case mfeFunction       : {
                               printf( "Niepoprawne wywolanie funkcji\n" );
                               err();
                               break;
                             };

    case mfeAssociation    : {
                               printf( "FUNKCJA SKOJARZONA NIE JEST ZAIMPLEMENTOWANA DLA TEJ DRUKARKI FISKALNEJ\n" );
                               getch();
                               break;
                             };

    case mfeAccess         : {
                               printf( "Funkcja skojarzona nie moze byc wykonana w tej chwili\n" );
                               err();
                               break;
                             }
  }
}


int hour;
int minute;

int year;
int month;
int day;

int version;
int subVersion;
char nameLib[256];

long lastTicketNo;

int taxA;
int taxB;
int taxC;
int taxD;
int taxE;
int taxF;

main()
{
  char znak;

  clrscr();

  /* 4.1. Dopuszczenie aplikacji */
  resErr( mfStart( "", 1 /* nr portu szeregowego COMx */ ) );
  if ( mfError() != mfeOk )
    exit(0);

  /* 2.1. Odczyt czasu zegara wewnetrznego DF */
  resErr( mfGetTime( &hour, &minute ) );
  printf( "\nCzas: %d:%d\n", hour, minute );

  /* 2.2. Odczyt daty zegara wewnetrznego DF */
  resErr( mfGetDate( &year, &month, &day ) );
  printf( "Data: %d-%d-%d\n", year, month, day );

  /* 2.3. Odczyt wersji DF */
  resErr( mfGetVersion( &version, &subVersion ) );
  printf( "Wersja: %d.%d\n", version, subVersion );

  /* 2.5. Odczyt numeru ostatniego paragonu */
  resErr( mfGetLastTicketNo( &lastTicketNo ) );
  printf( "Numer ostatniego paragonu: %ld\n", (long)lastTicketNo );

  /* 2.6. Odczyt stawek podatkowych */
  resErr( mfGetTax( &taxA, &taxB, &taxC, &taxD, &taxE, &taxF ) );
  printf( "Stawki podatkowe:  A=%d%%  B=%d%%  C=%d%%  D=%d%%  E=%d%%  F=%d%%\n",
          taxA/100, taxB/100, taxC/100, taxD/100, taxE/100, taxF/100 );

  /* 3.3. Odczyt wersji biblioteki */
  resErr( mfParLibVersion( &version, &subVersion, nameLib ) );
  printf( "Wersja biblioteki: %d.%d; dla modulu fiskalnego: %s\n", version, subVersion, nameLib );

  printf("\nWydrukowa paragon <T,N>: ");
  while( (znak = toupper(getch())) == 0 )
  {
  }

  if( znak == 'T' )
  {
     printf( "\nParagon w druku ..." );

     /* 6.2. Rozpoczecie wydruku paragonu  */
     resErr( mfBeginTicket( -1 ) );

     /* 6.3. Wydruku linii paragonu  */
     resErr( mfLineTicket(
        1,               /* numer towaru - ignorowany */
        "TOWAR TESTOWY", /* nazwa towaru */
        'A',             /* stawka A..G (zwolniony) */
        "szt",           /* jednostka miary */
        2500,            /* cena w groszach: 25.00,- */
        1000,            /* ilosc (1 szt) */
        -1 )             /* wartosc (niech biblioteka sama liczy) */ );

     /* 6.6. Zakonczenie paragonu  */
     resErr( mfEndTicket(
        1000,             /* rabat procentowy do caej transakcji (10%) */
        300,              /* rabat kwotowy podany informacyjnie (3.00,-) */
        120,              /* numer transakcji z aplikacji (informacyjnie) */
        1500 ,"Czek",     /* pierwsza patnosc  15.00,- */
        1000 ,"VISA",     /* druga    patnosc  10.00,- */
        10000,"Gotwka",  /* trzecia  patnosc 100.00,- */
        9500, "Gotwka",  /* reszta w kwocie    95.00,- */
        500,"Butelki",    /* dodanie kaucji w kwocie 5.00,- */
	"235",            /* nr stolika informacyjnie */
        "" )              /* nazwisko klienta */ );
  }


  printf("\nWydrukowa fakture <T,N>: ");
  while( (znak = toupper(getch())) == 0 )
  {
  }

  if( znak == 'T' )
  {
     printf( "\nFaktura w druku ..." );

     resErr( mfFaktStart(
             0,          /* wysuw - ilo pustych lini przed drukowaniem  */
             0,          /* typ - typ dokumentu */
             0,          /* napis - napis okrelajcy */
             52,         /* linii - ilo lini na pojedynczej kartce papieru*/
             1,          /* typRamki - typ ramki nagwkowej */
             "1234/97",  /* nrFakt - numer dokumentu */
             "",         /* nrOrg - tu nie uywany */
             "Paris",    /* miasto - miasto wystawienia */
             "12011997", /* dataWyst - data wystawienia */
             "10011997", /* dataSprz - data sprzedarzy */
             "4444",          /* nrParag - numer paragonu */
             "66",            /* nrKasy -  numer kasy */
             "UPOS SYSTEM",   /* sprzedawca nazwa sprzedawcy */
             "555-010-44-31", /* sprzedawcaNIP - NIP sprzedawcy */
             "John Brown",    /* nabywca nazwa nabywcy */
             "456-233-11-22", /* nabywcaNIP - NIP nabywcy */
             "",              /* transport - napis rezerwowy - ignorowany */
             "PKO BP",        /* bank - nazwa banku i numer konta */
             "VISA",          /* platnosc - sposb patnoci*/
             "",              /* ermin - napis rezerwowy - ignorowany */
             30,              /* paperInTimeout - czas w sekundach na woenie papieru */
             30               /* paperOutTimeout -czas w sekundach na wyjcie papieru */
     )
     );

/* 13.2 Wydruk linii faktury */
     resErr( mfFaktLinia(
             "COCA-COLA",     /* nazwa - nazwa towaru */
             "SWW 1234",      /* sww - SWW indeks */
             "szt",           /* jm - jednostka miary */
             "2.00",          /* ilosc - ilo */
             "10.00",         /* cena - cena */
             "16.39",         /* wartNetto - warto netto */
             "20.00",         /* wartBrutto - warto brutto */
             "22",            /* stawka - stawka podatku */
             "3.61",          /* wartPTU - warto podatku */
             ""               /* wartOpl - parametr rezerwowy ignorowany */
     ) );

/* 13.3 Zakonczenie faktury */
     resErr( mfFaktKoniec(
             "20 zlotych",      /* slownie - sownie ile do zapaty */
             "20.00",           /* doZapl - warto do zapaty */
             "Jan Kowalski",    /* nazwaSprz - nazwa sprzedawcy */
             "Wojciech Pych",   /* nazwaOdb nazwa klienta */
             "Zapraszamy ponownie", /* dopiski - dopiski swobodne */
             "16.39", "20.00", "22", "3.61",
                  "",      "",   "",     "",
                  "",      "",   "",     "",
                  "",      "",   "",     "",
                  "",      "",   "",     "",
                  "",      "",   "",     "",
             "",
             "16.39", "20.00",       "3.61"
     ) );

  }

  return 0;
}
