#DEFINE   MFEOK     0

# define UPPER_KEY_Y  89
# define SMALL_KEY_Y  121

# define UPPER_KEY_T  84
# define SMALL_KEY_T  116

PRIVATE res := 0

PRIVATE hour     := 0
PRIVATE minute   := 0

PRIVATE year     := 0
PRIVATE month    := 0
PRIVATE day      := 0

PRIVATE version  := 0
PRIVATE subVersion  := 0
PRIVATE versionName := ''

PRIVATE lastTicketNo := 0

PRIVATE taxA := 0
PRIVATE taxB := 0
PRIVATE taxC := 0
PRIVATE taxD := 0
PRIVATE taxE := 0
PRIVATE taxF := 0

PRIVATE nKey := 0

PRIVATE cena := 0
PRIVATE ilosc:= 0

  Clear Screen

  /* 4.1. Dopuszczenie aplikacji */
  res := cfStart( "", 1 )
                   // ^ - numer portu szeregowego
  err()
  if (cfError() <> MFEOK)
    Quit
  endif

  /* 2.1. Odczyt czasu zegara wewnetrznego DF */
  res := cfGetTime( @hour, @minute )
  QOUT( "Czas: "+MakeSTR(hour)+':'+MakeSTR(minute) )
  err()

  /* 2.2. Odczyt daty zegara wewnetrznego DF */
  res := cfGetDate( @year, @month, @day )
  QOUT( "Data: ", MakeSTR(year),'/',MakeSTR(month),'/',MakeSTR(day) )
  err()

  /* 2.3. Odczyt wersji DF */
  res := cfGetVersi( @version, @subVersion )
  QOut( "Wersja: ", MakeSTR(version),'.', MakeSTR(subVersion) )
  err()

  /* 2.5. Odczyt numeru ostatniego paragonu */
  res := cfGetLastT( @lastTicketNo )
  QOut( "Numer ostatniego paragonu: ", MakeSTR(lastTicketNo) )
  err()

  /* 2.6. Odczyt stawek podatkowych */
  res := cfGetTax( @taxA, @taxB, @taxC, @taxD, @taxE, @taxF )
  QOut( 'Stawki podatkowe:  A=', ALLTRIM(STR(taxA/100,5,2)),;
	                  ' B=', ALLTRIM(STR(taxB/100,5,2)),;
                          ' C=', ALLTRIM(STR(taxC/100,5,2)),;
	                  ' D=', ALLTRIM(STR(taxD/100,5,2)),;
                          ' E=', ALLTRIM(STR(taxE/100,5,2)),;
                          ' F=', ALLTRIM(STR(taxF/100,5,2)) )
  err()

  /* 3.3. Odczyt wersji biblioteki */
  res := cfParLibVe( @version, @subVersion, @versionName )
  QOut( "Wersja biblioteki: ", MakeSTR(version), '.', MakeSTR(subVersion), versionName )
  err()

  QOut ()
  QOut ('Wydrukowa paragon <T,N>: ')

  nKey := InKey (0)

  if nKey = UPPER_KEY_Y .or. nKey = SMALL_KEY_Y .or. nKey = UPPER_KEY_T .or. nKey = SMALL_KEY_T

    /* 6.2. Rozpoczecie wydruku paragonu */
    res := cfBeginTic (-1)

    /* 6.3. Wydruku linii paragonu */
    cena  = 2.51
    ilosc = 1.000
    res := cfLineTicket (1, 'TOWAR TESTOWY', 'A', 'szt',;
                         Round(cena*100,0), Round(ilosc*1000,0) , -1)
      // Pamietaj o Round. Wyprobuj wydruk bez Round dla ceny.

      // 1                { numer towaru - ignorowany }
      // 'TOWAR TESTOWY'  { nazwa towaru }
      // 'A'              { stawka A..G (zwolniony) }
      // 'szt'            { jednostka miary }
      // cena             { cena w groszach: 25.00,- }
      // ilosc            { ilosc (1 szt) }
      // -1               { wartosc (niech biblioteka sama liczy) }

    /* 6.6. Zakonczenie paragonu  */
    res := cfEndTicket ( 1000, 300, 120, 1500 ,'Czek', 1000 ,'VISA', 10000,;
                        'Gotwka', 9500, 'Gotwka', 500, 'Butelki', '235','')

      // 1000              { rabat procentowy do caej transakcji (10%) }
      // 300               { rabat kwotowy podany informacyjnie (3.00,-) }
      // 120               { numer transakcji z aplikacji (informacyjnie) }
      // 1500 ,'Czek'      { pierwsza patnosc  15.00,- }
      // 1000 ,'VISA'      { druga    patnosc  10.00,- }
      // 10000,'Gotwka'   { trzecia  patnosc 100.00,- }
      // 9500, 'Gotwka'   { reszta w kwocie    95.00,- }
      // 500,'Butelki'     { dodanie kaucji w kwocie 5.00,- }
      // '235'             { nr stolika informacyjnie }
      // ''                { nazwisko odbiorcy }
  endif

  QOut ()
  QOut ('Wydrukowa fakture <T,N>: ')

  nKey := InKey (0)

  if nKey = UPPER_KEY_Y .or. nKey = SMALL_KEY_Y .or. nKey = UPPER_KEY_T .or. nKey = SMALL_KEY_T



     QOUT( 'Faktura w druku ...' );

     /* 13.1 Rozpoczcie faktury */
     res:= cfFaktStart( 0, 0, 0, 52, 1,'1234/97','','Warszawa','12011997',;
             '10011997','4444','66','UPOS SYSTEM','555-010-44-31','John Brown',;
             '456-233-11-22','','PKO BP','VISA','',30, 30)

//             0          { wysuw - ilo pustych lini przed drukowaniem  }
//             0          { typ - typ dokumentu }
//             0          { napis - napis okrelajcy }
//             52         { linii - ilo lini na pojedynczej kartce papieru}
//             1          { typRamki - typ ramki nagwkowej }
//             '1234/97'  { nrFakt - numer dokumentu }
//             ''         { nrOrg - tu nie uywany }
//             'Warszawa' { miasto - miasto wystawienia }
//             '12011997' { dataWyst - data wystawienia }
//             '10011997' { dataSprz - data sprzedarzy }
//             '4444'          { nrParag - numer paragonu }
//             '66'            { nrKasy -  numer kasy }
//             'UPOS SYSTEM'   { sprzedawca nazwa sprzedawcy }
//             '"555-010-44-31' { sprzedawcaNIP - NIP sprzedawcy }
//             'John Brown'    { nabywca nazwa nabywcy }
//             '456-233-11-22' { nabywcaNIP - NIP nabywcy }
//             ''              { transport - napis rezerwowy - ignorowany }
//             'PKO BP'        { bank - nazwa banku i numer konta }
//             'VISA'          { platnosc - sposb patnoci}
//             ''              { ermin - napis rezerwowy - ignorowany }
//             30              { paperInTimeout - czas w sekundach na woenie papieru }
//             30               { paperOutTimeout -czas w sekundach na wyjcie papieru }

     /* 13.2 Wydruk linii faktury */
     res:= cfFaktLinia('COCA-COLA','SWW 1234','szt','2.00','10.00','16.39','20.00',;
             '22','3.61','')

//             'COCA-COLA'     { nazwa - nazwa towaru }
//             'SWW 1234'      { sww - SWW indeks }
//             'szt'           { jm - jednostka miary }
//             '2.00'          { ilosc - ilo }
//             '10.00'         { cena - cena }
//             '16.39'         { wartNetto - warto netto }
//             '20.00'         { wartBrutto - warto brutto }
//             '22'            { stawka - stawka podatku }
//             '3.61'          { wartPTU - warto podatku }
//             ''               { wartOpl - parametr rezerwowy ignorowany }

     /* 13.3 Zakonczenie faktury */
     res:= cfFaktKoniec('20 zlotych','20.00','Jan Kowalski','Wojtek Pych','Zapraszamy ponownie',;
             '16.39', '20.00', '22', '3.61','','','','','','','','','','','','',;
             '','','','','','','','','','16.39','20.00','3.61')


//             '20 zlotych',          { slownie - sownie ile do zapaty }
//             '20.00',               { doZapl - warto do zapaty }
//             'Jan Kowlaski',        { nazwaSprz - nazwa sprzedawcy }
//             'Wojtek Pych',         { nazwaOdb nazwa klienta }
//             'Zapraszamy ponownie', { dopiski - dopiski swobodne }
//             '16.39', '20.00', '22', '3.61',
//                  '',      '',   '',     '',
//                  '',      '',   '',     '',
//                  '',      '',   '',     '',
//                  '',      '',   '',     '',
//                  '',      '',   '',     '',
//             '',
//             '16.39', '20.00',       '3.61'

  endif


function err( )
 LOCAL groupMsg := ''
 LOCAL detailMsg := ''

  if ( res != 0 )
    Qout( 'BLAD WYWOLANIA FUNKCJI' )
  endif

  if ( res == 1 )
    Qout( 'FUNKCJA NIEZAIMPLEMENTOWANA' )
    Qout()
  endif

  if ( cfError() != MFEOK )
    cfParMessa( cfError(), @groupMsg, @detailMsg )
    Qout( groupMsg, ', ', detailMsg )
    Qout( 'Nacisnij dowolny klawisz ...')
    Inkey(0)
  endif
RETURN nil

function MakeSTR ( numeric )
  LOCAL tekst := ALLTRIM(STR( numeric, 10, 0))
return tekst
