Program MFBOTEST;
uses
  Crt, MFBO;

procedure stop;
var z: char;
begin
  while keyPressed do
    z := readKey;

  z := readKey;
end;

procedure err;
var groupMsg  : string;
    detailMsg : string;
begin
  if mfError <> mfeOk then
    begin
      mfParMessage( mfError, groupMsg, detailMsg );
      writeln( groupMsg, ', ', detailMsg );
      stop;
    end;
end;

procedure resErr( res: integer );
begin
  case res of
    mfeOk             :;
    mfeImplementation : begin
                          writeln( 'FUNKCJA NIE JEST ZAIMPLEMENTOWANA DLA TEJ DRUKARKI FISKALNEJ' );
                          stop;
                        end;

    mfeApplication    : begin
                          writeln( 'BLAD APLIKACJI' );
                          halt;
                        end;

    mfeFunction       : begin
                          writeln( 'Niepoprawne wywolanie funkcji' );
                          err;
                        end;

    mfeAssociation    : begin
                          writeln( 'FUNKCJA SKOJARZONA NIE JEST ZAIMPLEMENTOWANA DLA TEJ DRUKARKI FISKALNEJ' );
                          stop;
                        end;

    mfeAccess         : begin
                          writeln( 'Funkcja skojarzona nie moze byc wykonana w tej chwili' );
                          err;
                        end;
  end;
end;

var
  hour, minute : integer;
  year, month, day : integer;

  version, subVersion : integer;
  nameLib : string;

  lastTicketNo : longint;
  taxA, taxB, taxC, taxD, taxE, taxF: integer;

begin
  clrscr;

  (* 4.1. Dopuszczenie aplikacji *)
  resErr( mfStart( '', 1 {nr portu szeregowego COM} ) );
  if mfError <> mfeOk then begin
    writeln('Moze niewlasciwy numer portu szeregowego');
    halt
  end;

  (* 2.1. Odczyt czasu zegara wewnetrznego DF *)
  resErr( mfGetTime( hour, minute ) );
  writeln( 'Czas: ', hour:2, ':', minute:2 );

  (* 2.2. Odczyt daty zegara wewnetrznego DF *)
  resErr( mfGetDate( year, month, day ) );
  writeln( 'Data: ', year:4, '-', month:2, '-', day:2 );

  (* 2.3. Odczyt wersji DF *)
  resErr( mfGetVersion( version, subVersion ) );
  writeln( 'Wersja modulu fiskalnego : ', version, '.', subVersion );

  (* 2.5. Odczyt numeru ostatniego paragonu *)
  resErr( mfGetLastTicketNo( lastTicketNo ) );
  writeln( 'Numer ostatniego paragonu: ', lastTicketNo );

  (* 2.6. Odczyt stawek podatkowych *)
  resErr( mfGetTax( taxA, taxB, taxC, taxD, taxE, taxF ) );
  writeln( 'Stawki podatkowe: ',
           'A=', taxA/100:5:2, '  B=', taxB/100:5:2,
           '  C=', taxC/100:5:2, '  D=', taxD/100:5:2,
           '  E=', taxE/100:5:2, '  F=', taxF/100:5:2 );

  (* 3.3. Odczyt wersji biblioteki *)
  resErr( mfParLibVersion( version, subVersion,nameLib ) );
  writeln( 'Wersja biblioteki: ', version, '.', subVersion, ' dla modulu fiskalnego: ',nameLib );

  (* 4.3. Definicja numeru kasy i kasjera *)
  resErr( mfDefPOS( 1 {nr kasy}, 10 {nr kasjera}, 'Jan Kowalski' ) );

  writeln;
  write('Wydrukowa paragon <T,N>: ');
  repeat until KeyPressed;

  if UpCase(ReadKey)='T' then begin

     (* 6.2. Rozpoczecie wydruku paragonu  *)
     resErr( mfBeginTicket( -1 ) );

     (* 6.3. Wydruku linii paragonu  *)
     resErr( mfLineTicket(
        1,               { numer towaru - ignorowany }
        'TOWAR TESTOWY', { nazwa towaru }
        'A',             { stawka A..G (zwolniony) }
        'szt',           { jednostka miary }
        2500,            { cena w groszach: 25.00,- }
        1000,            { ilosc (1 szt) }
        -1 )             { wartosc (niech biblioteka sama liczy) } );

     (* 6.6. Zakonczenie paragonu  *)
     resErr( mfEndTicket(
        1000,             { rabat procentowy do caej transakcji (10%) }
        300,              { rabat kwotowy podany informacyjnie (3.00,-) }
        120,              { numer transakcji z aplikacji (informacyjnie) }
        1500 ,'Czek',     { pierwsza patnosc  15.00,- }
        1000 ,'VISA',     { druga    patnosc  10.00,- }
        10000,'Gotwka',  { trzecia  patnosc 100.00,- }
        9500, 'Gotwka',  { reszta w kwocie    95.00,- }
        500,'Butelki',    { dodanie kaucji w kwocie 5.00,- }
	'235',            { nr stolika informacyjnie }
        '' )              { nazwisko klienta } );

  end;

  writeln;
  write('Wydrukowa faktur <T,N>: ');
  repeat until KeyPressed;

  if UpCase(ReadKey)='T' then begin

     (* 13.1 Rozpoczcie faktury *)
     resErr( mfFaktStart(
             0,          { wysuw - ilo pustych lini przed drukowaniem  }
             0,          { typ - typ dokumentu }
             0,          { napis - napis okrelajcy }
             52,         { linii - ilo lini na pojedynczej kartce papieru}
             1,          { typRamki - typ ramki nagwkowej }
             '1234/97',  { nrFakt - numer dokumentu }
             '',         { nrOrg - tu nie uywany }
             'Knurw',   { miasto - miasto wystawienia }
             '12011997', { dataWyst - data wystawienia }
             '10011997', { dataSprz - data sprzedarzy }
             '4444',          { nrParag - numer paragonu }
             '66',            { nrKasy -  numer kasy }
             'UPOS SYSTEM',   { sprzedawca nazwa sprzedawcy }
             '555-010-44-31', { sprzedawcaNIP - NIP sprzedawcy }
             'John Brown',    { nabywca nazwa nabywcy }
             '456-233-11-22', { nabywcaNIP - NIP nabywcy }
             '',              { transport - napis rezerwowy - ignorowany }
             'PKO BP',        { bank - nazwa banku i numer konta }
             'VISA',          { platnosc - sposb patnoci}
             '',              { termin - napis rezerwowy - ignorowany }
             30,              { paperInTimeout - czas w sekundach na woenie papieru }
             30               { paperOutTimeout -czas w sekundach na wyjcie papieru }
     ) );

     (* 13.2 Wydruk linii faktury *)
     resErr( mfFaktLinia(
             'COCA-COLA',     { nazwa - nazwa towaru }
             'SWW 1234',      { sww - SWW indeks }
             'szt',           { jm - jednostka miary }
             '2.00',          { ilosc - ilo }
             '10.00',         { cena - cena }
             '16.39',         { wartNetto - warto netto }
             '20.00',         { wartBrutto - warto brutto }
             '22',            { stawka - stawka podatku }
             '3.61',          { wartPTU - warto podatku }
             ''               { wartOpl - parametr rezerwowy ignorowany }
     ) );

     (* 13.3 Zakonczenie faktury *)
     resErr( mfFaktKoniec(
             '20 zlotych',          { slownie - sownie ile do zapaty }
             '20.00',               { doZapl - warto do zapaty }
             'Jan Kowalski',        { nazwaSprz - nazwa sprzedawcy }
             'Jurek Woniak',       { nazwaOdb nazwa klienta }
             'Zapraszamy ponownie', { dopiski - dopiski swobodne }
             '16.39', '20.00', '22', '3.61',
                  '',      '',   '',     '',
                  '',      '',   '',     '',
                  '',      '',   '',     '',
                  '',      '',   '',     '',
                  '',      '',   '',     '',
             '',
             '16.39', '20.00',       '3.61'
     ) );

  end;

End.